routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () { return view('welcome'); })->name('welcome');

Route::get('search_client', 'ClientsController@search')->name('search_client');
Route::get('search_tractament', 'TractamentsController@search')->name('search_tractament');

Route::post('clients/afegir_tractament', 'ClientsController@afegirTractament')->name('afegirTractament');

Route::resource('clients', 'ClientsController');

Route::resource('tractaments', 'TractamentsController');

app/Client.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Client extends Model
{
    protected $fillable = ['nom', 'cognoms', 'data_naixement'];

    public function tractaments() {
        return $this->belongsToMany('App\Tractament');
    }

}

app/Tractament.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Tractament extends Model
{
    protected $fillable = ['nom', 'descripcio'];

    public function clients() {
        return $this->belongsToMany('App\Client');
    }

}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/ClientsController.php
<?php

namespace App\Http\Controllers;

use App\Client;
use App\Tractament;
use Illuminate\Http\Request;

class ClientsController extends Controller {

    public function index() {
        $clients = Client::paginate(8);

        return view('clients.index')->with('clients',$clients);
    }

    public function create() {
        return view('clients.create');
    }

    public function store(Request $request) {

        $request->validate([
            'nom' => 'required',
            'cognoms' => 'required',
            'dataNaixament' => 'required'
        ]);

        $client = new Client();

        $client->nom = $request->input('nom');
        $client->cognoms = $request->input('cognoms');
        $client->data_naixement = $request->input('dataNaixament');

        $client->save();

        return redirect()->route('clients.index')->with('success', 'S\'ha afegit el client.');
    }

    public function show($id) {
        $client = Client::find($id);
        $tractaments = Tractament::all();

        return view('clients.show')->with('client', $client)->with('tractaments', $tractaments);
    }

    public function edit($id) {
        $client = Client::find($id);

        return view('clients.edit')->with('client', $client);
    }


    public function update(Request $request, $id) {

        $request->validate([
            'nom' => 'required',
            'cognoms' => 'required',
            'dataNaixament' => 'required'
        ]);

        $client = Client::find($id);

        $client->nom = $request->input('nom');
        $client->cognoms = $request->input('cognoms');
        $client->data_naixement = $request->input('dataNaixament');

        $client->save();

        return redirect()->route('clients.index')->with('success','S\'ha modificat el client.');
    }

    public function destroy($id) {
        $client = Client::find($id);

        $client->delete();


        return redirect()->route('clients.index')->with('success','S\'ha eliminat el client.');
    }

    public function search(Request $request) {
        $search = $request->get('search');

        $array = explode(" ", $request->get('search'));

        if(count($array) < 2){
            $posts = Client::where('nom', 'like', '%' . $search . '%')->orWhere('cognoms', 'like', '%' . $search . '%')->paginate(6);

        }else{
            $posts = Client::where('nom', 'like', '%' . $array[0] . '%')->orWhere('cognoms', 'like', '%' . $array[1] . '%')->paginate(6);
        }

        if(count($posts) == 0){
            return redirect()->route('clients.index')->with('success', 'No s\'ha trobat cap client');
        }

        return view('clients.index')->with('clients', $posts);
    }

    public function afegirTractament(Request $request){
        $id_cliente = $request->get('client_id');
        $id_tratamiento = $request->get('product_id');

        $client = Client::find($id_cliente);
        $tractaments = Tractament::all();

        $client->tractaments()->attach($id_tratamiento);

        return view('clients.show')->with('client', $client)->with('tractaments', $tractaments);
    }

}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/TractamentsController.php
<?php

namespace App\Http\Controllers;

use App\Tractament;
use Illuminate\Http\Request;

class TractamentsController extends Controller {

    public function index() {
        $tractaments = Tractament::paginate(8);

        return view('tractaments.index')->with('tractaments',$tractaments);
    }

    public function create() {
        return view('tractaments.create');
    }

    public function store(Request $request) {

        $request->validate([
            'nom' => 'required',
            'descripcio' => 'required'
        ]);

        $tractament = new Tractament([
            'nom' => $request->input('nom'),
            'descripcio' => $request->input('descripcio'),
        ]);

        $tractament->save();

        return redirect()->route('tractaments.index')->with('success', 'S\'ha afegit el tractament.');
    }

    public function show($id)  {
        $tractament = Tractament::find($id);

        return view('tractaments.show')->with('tractament', $tractament);
    }

    public function edit($id) {
        $tractament = Tractament::find($id);

        return view('tractaments.edit')->with('tractament', $tractament);
    }

    public function update(Request $request, $id) {
        $tractament = Tractament::find($id);

        $tractament->nom = $request->input('nom');
        $tractament->descripcio = $request->input('descripcio');

        $tractament->save();

        return redirect()->route('tractaments.index')->with('success','S\'ha modificat el tractament.');
    }

    public function destroy($id) {
        $tractament = Tractament::find($id);

        $tractament->delete();

        return redirect()->route('tractaments.index')->with('success','S\'ha eliminat el tractament.');
    }

    public function search(Request $request) {
        $search = $request->get('search');

        $posts = Tractament::where('nom', 'like', '%' . $search . '%')->paginate(6);

        return view('tractaments.index')->with('tractaments', $posts);
    }

}

resources/views/clients/create.blade.php
@extends('layout.main')

@section('content')
    <h1>Afegir Client</h1>

    <div class="row justify-content-center">
        <div class="col">
            <form method="post" action="{{route('clients.store')}}">
                @csrf
                <div class="form-group">
                    <label for="nom">Nom:</label>
                    <input type="text" class="form-control" name="nom" id="nom" required>

                    <label for="cognoms">Cognoms</label>
                    <input type="text" class="form-control" name="cognoms" id="cognoms" required>

                    <label for="dataNaixament">Data Naixement:</label>
                    <input type="date" class="form-control" name="dataNaixament" id="dataNaixament" required>

                    <button type="submit" class="btn btn-primary mt-2">Afegir</button>
                </div>
            </form>
        </div>
    </div>
@stop

resources/views/clients/edit.blade.php
@extends('layout.main')

@section('content')
    <h1>Editar Client</h1>

    <div class="row justify-content-center">
        <div class="col">
            <form action="{{route('clients.update', ['client' => $client->id])}}" method="POST">
                @csrf {{method_field('PUT')}}
                <div class="form-group">
                    <label for="nom">Nom:</label>
                    <input type="text" class="form-control" name="nom" id="nom" value="{{$client->nom}}" required>

                    <label for="cognoms">Cognoms</label>
                    <input type="text" class="form-control" name="cognoms" id="cognoms" value="{{$client->cognoms}}" required>

                    <label for="dataNaixament">Data Naixement:</label>
                    <input type="date" class="form-control" name="dataNaixament" id="dataNaixament" value="{{$client->data_naixement}}" max="{{date('Y-m-d')}}" required>

                    <a href="{{route('clients.index')}}"><button type="button" class="btn btn-primary mt-2">Tornar</button></a>
                    <button type="submit" class="btn btn-primary mt-2">Modificar</button>
                </div>
            </form>
        </div>
    </div>
@stop

resources/views/clients/index.blade.php
@extends('layout.main')

@section('content')

    <div class="float-right m-5">
        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#modalCreate"> Afegir Client </button>

        <div class="mt-2">
            <form action="{{route('search_client')}}" method="GET">
                <div class="input-group">
                    <input class="form-control border-secondary py-2" type="search" name="search">
                    <div class="input-group-append">
                        <button class="btn btn-outline-secondary" type="submit">
                            <i class="fa fa-search"></i>
                        </button>
                    </div>
                </div>
            </form>
        </div>
    </div>

    <h2 class="display-3">Clients</h2>
    <p class="lead">Llistat de Clients</p>

    <div class="col-sm-12">
        @if(session()->get('success'))
            <div class="alert alert-success">
                {{ session()->get('success') }}
            </div>
        @endif

        @if ($errors->any())
            <div class="alert alert-danger">
                <ul>
                    @foreach ($errors->all() as $error)
                        <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
        @endif
    </div>

    <table class="table table-striped">
        <thead>
            <tr>
                <th scope="col">Nom</th>
                <th scope="col">Cognoms</th>
                <th scope="col">Data Naixement</th>
                <th scope="col">Accions<th>
            </tr>
        </thead>

        <tbody>
        @foreach($clients as $client)
            <tr>
                <th>{{$client->nom}}</th>
                <th>{{$client->cognoms}}</th>
                <th>{{date('d-m-Y', strtotime($client->data_naixement))}}</th>
                <th class="align-content-center">
                    <a href="{{route('clients.show', $client->id)}}" class="float-left">
                        <button type="button" class="btn-primary btn-sm">Mostrar</button>
                    </a>

                    <a href="{{route('clients.edit', $client->id)}}" class="float-left mr-2 ml-2">
                        <button type="button" class="btn-success btn-sm">Modificar</button>
                    </a>

                    <button data-toggle="modal" onclick="deleteData({{$client->id}})" data-target="#DeleteModal" class="btn-danger btn-sm">Eliminar</button>

                </th>
            </tr>
        @endforeach
        </tbody>
    </table>

    {{ $clients->links() }}

    <a href="{{route('welcome')}}"><button type="button" class="btn btn-primary">Tornar</button></a>

    <!--    Modal Afegir  -->
    <div class="modal fade" id="modalCreate" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Afegir Client</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form method="post" action="{{route('clients.store')}}">
                        @csrf
                        <div class="form-group">
                            <label for="nom">Nom:</label>
                            <input type="text" class="form-control" name="nom" id="nom" required>

                            <label for="cognoms">Cognoms</label>
                            <input type="text" class="form-control" name="cognoms" id="cognoms" required>

                            <label for="dataNaixament">Data Naixement:</label>
                            <input type="date" class="form-control" name="dataNaixament" id="dataNaixament" max="{{date('Y-m-d')}}" required>

                            <button type="submit" class="btn btn-primary mt-2 float-right">Afegir</button>
                        </div>
                    </form>
                </div>

            </div>
        </div>
    </div>
    <!--    /Modal Afegir  -->

    <!--    Modal Eliminar  -->
    <div id="DeleteModal" class="modal fade text-danger" role="dialog">
        <div class="modal-dialog ">
            <form action="" id="deleteForm" method="post">
                <div class="modal-content">
                    <div class="modal-header bg-danger">
                        <h4 class="modal-title text-center" style="color:white;">Eliminar Client</h4>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        @csrf @method('DELETE')
                        <p class="text-center">Estàs segur que vols eliminar el client?</p>
                    </div>
                    <div class="modal-footer">
                        <button type="submit" name="" class="btn btn-danger" data-dismiss="modal" onclick="formSubmit()">Eliminar</button>
                    </div>
                </div>
            </form>
        </div>
    </div>

    <script type="text/javascript">
        function deleteData(id) {
            var id = id;
            var url = '{{ route("clients.destroy", ":id") }}';
            url = url.replace(':id', id);
            $("#deleteForm").attr('action', url);
        }

        function formSubmit() {
            $("#deleteForm").submit();
        }
    </script>
    <!--    /Modal Eliminar  -->
@stop

resources/views/clients/show.blade.php
@extends('layout.main')

@section('content')

    <div class="float-right m-5">
        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal"> Afegir Tractament </button>
    </div>

    <h2 class="display-3">{{$client->nom}} {{$client->cognoms}}</h2>

    <table class="table table-striped" id="tablaAutors">
        <thead>
        <tr>
            <th scope="col">Tractament</th>
        </tr>
        </thead>

        <tbody>
            @foreach($client->tractaments as $tractament)
                <tr>
                    <td>{{$tractament->nom}}</td>
                </tr>
            @endforeach
        </tbody>
    </table>

    <a href="{{route('clients.index')}}"><button type="button" class="btn btn-primary mt-2">Tornar</button></a>

    <!-- Modal Afegir Tractament -->
    <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Afegir Tractament</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form action="{{route('afegirTractament')}}" method="POST">
                        @csrf
                        <select class="form-control" name="product_id">
                            <option>Selecciona Tractament</option>
                            @foreach ($tractaments as $tractament)
                                <option value="{{ $tractament->id }}">
                                    {{ $tractament->nom}}
                                </option>
                            @endforeach
                        </select>

                        <input type="hidden" id="client_id" name="client_id" value="{{$client->id}}">

                        <div class="mt-2">
                            <button type="submit" class="btn btn-primary float-right">Afegir</button>
                        </div>

                    </form>
                </div>
            </div>
        </div>
    </div>
    <!-- /Modal Afegir Tractament -->

@stop

resources/views/layout/main.blade.php
<!DOCTYPE html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Carles Miranda</title>

    <link href="https://fonts.googleapis.com/css?family=Nunito:200,600" rel="stylesheet">
    <link href="{{asset('css/style.css')}}" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.3/css/bootstrap.min.css" />
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css  " />

    <script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery-validate/1.19.0/jquery.validate.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js"></script>

</head>
<body>

<nav class="navbar navbar-expand-lg navbar-light bg-light">
    <a class="navbar-brand" href="{{route('welcome')}}">Inici</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>

    <div class="collapse navbar-collapse" id="navbarSupportedContent">
        <ul class="navbar-nav mr-auto">
            <li class="nav-item active">
                <a class="nav-link" href="{{route('clients.index')}}">Clients</a>
            </li>
            <li class="nav-item active">
                <a class="nav-link" href="{{route('tractaments.index')}}">Tractaments</a>
            </li>
        </ul>
    </div>
</nav>

    <div class="container-fluid">
        @yield('content')
    </div>
</body>
</html>

resources/views/tractaments/create.blade.php
@extends('layout.main')

@section('content')
    <h1>Afegir Tractament</h1>

    <div class="row justify-content-center">
        <div class="col">
            <form method="post" action="{{route('tractaments.store')}}">
                @csrf
                <div class="form-group">
                    <label for="nom">Nom:</label>
                    <input type="text" class="form-control" name="nom" id="nom" required>

                    <label for="descripcio">Descripcio: </label>
                    <textarea class="form-control rounded-0" rows="3" name="descripcio" id="descripcio"></textarea>

                    <button type="submit" class="btn btn-primary">Afegir</button>
                </div>
            </form>
        </div>
    </div>
@stop

resources/views/tractaments/edit.blade.php
@extends('layout.main')

@section('content')
    <h1>Modificar Tractament</h1>

    <div class="row justify-content-center">
        <div class="col">
            <form action="{{route('tractaments.update', ['tractament' => $tractament->id])}}" method="POST">
                @csrf {{method_field('PUT')}}
                <div class="form-group">
                    <label for="nom">Nom:</label>
                    <input type="text" class="form-control" name="nom" id="nom" value="{{$tractament->nom}}" required>

                    <label for="descripcio">Descripcio</label>
                    <textarea class="form-control rounded-0" rows="3" name="descripcio" id="descripcio" required>{{$tractament->descripcio}}</textarea>


                    <a href="{{route('tractaments.index')}}"><button type="button" class="btn btn-primary mt-2">Tornar</button></a>
                    <button type="submit" class="btn btn-primary mt-2">Modificar</button>
                </div>
            </form>
        </div>
    </div>
@stop

resources/views/tractaments/index.blade.php
@extends('layout.main')

@section('content')

    <div class="float-right m-5">
        <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal"> Afegir Tractament </button>

        <div class="mt-2">
            <form action="{{route('search_tractament')}}" method="GET">
                <div class="input-group">
                    <input class="form-control border-secondary py-2" type="search" name="search">
                    <div class="input-group-append">
                        <button class="btn btn-outline-secondary" type="submit">
                            <i class="fa fa-search"></i>
                        </button>
                    </div>
                </div>
            </form>
        </div>
    </div>

    <h2 class="display-3">Tractaments</h2>
    <p class="lead">Llistat de Tractaments</p>

    <div class="col-sm-12">
        @if(session()->get('success'))
            <div class="alert alert-success">
                {{ session()->get('success') }}
            </div>
        @endif

        @if ($errors->any())
            <div class="alert alert-danger">
                <ul>
                    @foreach ($errors->all() as $error)
                        <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
        @endif
    </div>

    <table class="table table-striped">
        <thead>
        <tr>
            <th scope="col">Nom</th>
            <th scope="col">Descripcio</th>
            <th scope="col">Accions<th>
        </tr>
        </thead>

        <tbody>
        @foreach($tractaments as $tractament)
            <tr>
                <th>{{$tractament->nom}}</th>
                <th>{{\Str::limit($tractament->descripcio)}}</th>
                <th class="align-content-center">
                    <a href="{{route('tractaments.show', $tractament->id)}}" class="float-left">
                        <button type="button" class="btn-primary btn-sm">Mostrar</button>
                    </a>

                    <a href="{{route('tractaments.edit', $tractament->id)}}" class="float-left mr-2 ml-2">
                        <button type="button" class="btn-success btn-sm">Modificar</button>
                    </a>

                    <button data-toggle="modal" onclick="deleteData({{$tractament->id}})" data-target="#DeleteModal" class="btn-danger btn-sm">Eliminar</button>

                </th>
            </tr>
        @endforeach
        </tbody>
    </table>

    {{ $tractaments->links() }}

    <a href="{{route('welcome')}}"><button type="button" class="btn btn-primary">Tornar</button></a>

    <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Afegir Tractament</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form method="post" action="{{route('tractaments.store')}}">
                        @csrf
                        <div class="form-group">
                            <label for="nom">Nom:</label>
                            <input type="text" class="form-control" name="nom" id="nom" required>

                            <label for="descripcio">Descripcion: </label>
                            <textarea class="form-control rounded-0" rows="3" name="descripcio" id="descripcio"></textarea>

                            <button type="submit" class="btn btn-primary mt-2 float-right">Afegir</button>
                        </div>
                    </form>
                </div>

            </div>
        </div>
    </div>

    <div id="DeleteModal" class="modal fade text-danger" role="dialog">
        <div class="modal-dialog ">
            <form action="" id="deleteForm" method="post">
                <div class="modal-content">
                    <div class="modal-header bg-danger">
                        <h4 class="modal-title text-center" style="color:white;">Eliminar Tractament</h4>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        @csrf @method('DELETE')
                        <p class="text-center">Estas seguro que quieres eliminar el tractament?</p>
                    </div>
                    <div class="modal-footer">

                        <button type="submit" name="" class="btn btn-danger" data-dismiss="modal" onclick="formSubmit()">Eliminar</button>

                    </div>
                </div>
            </form>
        </div>
    </div>

    <script type="text/javascript">
        function deleteData(id) {
            var id = id;
            var url = '{{ route("tractaments.destroy", ":id") }}';
            url = url.replace(':id', id);
            $("#deleteForm").attr('action', url);
        }

        function formSubmit() {
            $("#deleteForm").submit();
        }
    </script>
@stop

resources/views/tractaments/show.blade.php
@extends('layout.main')

@section('content')


    <div class="row justify-content-center">
        <div class="col">

            <h1 class="display-3">Tractaments</h1>

            <h2 class="display-3">{{$tractament->nom}}</h2>

            <p class="lead">{{$tractament->descripcio}}</p>

            <a href="{{route('tractaments.index')}}"><button type="button" class="btn btn-primary">Tornar</button></a>


        </div>

    </div>
@stop